﻿@inject UserAppState UserAppState
@inject IDialogService DialogService
@inject ISnackbar Snackbar
@inject NavigationManager NavManager
@inject Blazored.LocalStorage.ILocalStorageService localStorage
@implements IDisposable

<MudText>@(Common.Spacer(2))</MudText>
@if (UserAppState.AuthState == AuthState.Loading || UserAppState.AuthState == AuthState.Authenticating)
{
	<MudButton Size="Size.Small" Variant="Variant.Filled" Color="Color.Primary" Disabled="true">
		<MudProgressCircular Class="ms-n1" Size="Size.Small" Indeterminate="true" />
		@if (UserAppState.AuthState == AuthState.Loading)
		{
			<MudText Class="ms-2">Loading...</MudText>
		}
		else
		{
			<MudText Class="ms-2">Authenticating...</MudText>
		}
	</MudButton>
}
else if (UserAppState.IsAuthenticated)
{
	<MudButton Size="Size.Small" Variant="Variant.Filled" Color="Color.Secondary" OnClick="LogoutAsync" Class="my-2">Log Out</MudButton>
	@if (UserAppState.NumNotifications > 0)
	{
		<MudBadge Content="@UserAppState.NumNotifications" Overlap="true" Color="Color.Secondary" Class="my-1">
			<MudIconButton Icon="@Icons.Material.Filled.Email" Size="Size.Small" Color="Color.Primary" OnClick="ClickNotifications" Class="my-1"/>
		</MudBadge>
	}
	else
	{
		<MudIconButton Icon="@Icons.Material.Filled.Email" Size="Size.Small" Color="Color.Primary" OnClick="ClickNotifications" Class="my-2" Disabled=true />
	}
}
else
{
	<MudButton Size="Size.Small" Variant="Variant.Filled" Color="Color.Primary" OnClick="LoginAsync">Sign In</MudButton>
	@if (HasAttemptedAuth && UserAppState.AuthState != AuthState.NoCredentials)
	{
		Snackbar.Add(UserAppState.AuthError, Severity.Error);
	}
}